import * as $protobuf from "protobufjs";
/** Properties of an Update. */
export interface IUpdate {

    /** Update previewData */
    previewData?: (IPreviewData|null);

    /** Update canvasData */
    canvasData?: (ICanvasData|null);
}

/** Represents an Update. */
export class Update implements IUpdate {

    /**
     * Constructs a new Update.
     * @param [properties] Properties to set
     */
    constructor(properties?: IUpdate);

    /** Update previewData. */
    public previewData?: (IPreviewData|null);

    /** Update canvasData. */
    public canvasData?: (ICanvasData|null);

    /**
     * Creates a new Update instance using the specified properties.
     * @param [properties] Properties to set
     * @returns Update instance
     */
    public static create(properties?: IUpdate): Update;

    /**
     * Encodes the specified Update message. Does not implicitly {@link Update.verify|verify} messages.
     * @param message Update message or plain object to encode
     * @param [writer] Writer to encode to
     * @returns Writer
     */
    public static encode(message: IUpdate, writer?: $protobuf.Writer): $protobuf.Writer;

    /**
     * Encodes the specified Update message, length delimited. Does not implicitly {@link Update.verify|verify} messages.
     * @param message Update message or plain object to encode
     * @param [writer] Writer to encode to
     * @returns Writer
     */
    public static encodeDelimited(message: IUpdate, writer?: $protobuf.Writer): $protobuf.Writer;

    /**
     * Decodes an Update message from the specified reader or buffer.
     * @param reader Reader or buffer to decode from
     * @param [length] Message length if known beforehand
     * @returns Update
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): Update;

    /**
     * Decodes an Update message from the specified reader or buffer, length delimited.
     * @param reader Reader or buffer to decode from
     * @returns Update
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): Update;

    /**
     * Verifies an Update message.
     * @param message Plain object to verify
     * @returns `null` if valid, otherwise the reason why it is not
     */
    public static verify(message: { [k: string]: any }): (string|null);

    /**
     * Creates an Update message from a plain object. Also converts values to their respective internal types.
     * @param object Plain object
     * @returns Update
     */
    public static fromObject(object: { [k: string]: any }): Update;

    /**
     * Creates a plain object from an Update message. Also converts values to other types if specified.
     * @param message Update
     * @param [options] Conversion options
     * @returns Plain object
     */
    public static toObject(message: Update, options?: $protobuf.IConversionOptions): { [k: string]: any };

    /**
     * Converts this Update to JSON.
     * @returns JSON object
     */
    public toJSON(): { [k: string]: any };
}

/** Properties of a PreviewData. */
export interface IPreviewData {

    /** PreviewData json */
    json: string;
}

/** Represents a PreviewData. */
export class PreviewData implements IPreviewData {

    /**
     * Constructs a new PreviewData.
     * @param [properties] Properties to set
     */
    constructor(properties?: IPreviewData);

    /** PreviewData json. */
    public json: string;

    /**
     * Creates a new PreviewData instance using the specified properties.
     * @param [properties] Properties to set
     * @returns PreviewData instance
     */
    public static create(properties?: IPreviewData): PreviewData;

    /**
     * Encodes the specified PreviewData message. Does not implicitly {@link PreviewData.verify|verify} messages.
     * @param message PreviewData message or plain object to encode
     * @param [writer] Writer to encode to
     * @returns Writer
     */
    public static encode(message: IPreviewData, writer?: $protobuf.Writer): $protobuf.Writer;

    /**
     * Encodes the specified PreviewData message, length delimited. Does not implicitly {@link PreviewData.verify|verify} messages.
     * @param message PreviewData message or plain object to encode
     * @param [writer] Writer to encode to
     * @returns Writer
     */
    public static encodeDelimited(message: IPreviewData, writer?: $protobuf.Writer): $protobuf.Writer;

    /**
     * Decodes a PreviewData message from the specified reader or buffer.
     * @param reader Reader or buffer to decode from
     * @param [length] Message length if known beforehand
     * @returns PreviewData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): PreviewData;

    /**
     * Decodes a PreviewData message from the specified reader or buffer, length delimited.
     * @param reader Reader or buffer to decode from
     * @returns PreviewData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): PreviewData;

    /**
     * Verifies a PreviewData message.
     * @param message Plain object to verify
     * @returns `null` if valid, otherwise the reason why it is not
     */
    public static verify(message: { [k: string]: any }): (string|null);

    /**
     * Creates a PreviewData message from a plain object. Also converts values to their respective internal types.
     * @param object Plain object
     * @returns PreviewData
     */
    public static fromObject(object: { [k: string]: any }): PreviewData;

    /**
     * Creates a plain object from a PreviewData message. Also converts values to other types if specified.
     * @param message PreviewData
     * @param [options] Conversion options
     * @returns Plain object
     */
    public static toObject(message: PreviewData, options?: $protobuf.IConversionOptions): { [k: string]: any };

    /**
     * Converts this PreviewData to JSON.
     * @returns JSON object
     */
    public toJSON(): { [k: string]: any };
}

/** Properties of a CanvasData. */
export interface ICanvasData {

    /** CanvasData json */
    json: string;
}

/** Represents a CanvasData. */
export class CanvasData implements ICanvasData {

    /**
     * Constructs a new CanvasData.
     * @param [properties] Properties to set
     */
    constructor(properties?: ICanvasData);

    /** CanvasData json. */
    public json: string;

    /**
     * Creates a new CanvasData instance using the specified properties.
     * @param [properties] Properties to set
     * @returns CanvasData instance
     */
    public static create(properties?: ICanvasData): CanvasData;

    /**
     * Encodes the specified CanvasData message. Does not implicitly {@link CanvasData.verify|verify} messages.
     * @param message CanvasData message or plain object to encode
     * @param [writer] Writer to encode to
     * @returns Writer
     */
    public static encode(message: ICanvasData, writer?: $protobuf.Writer): $protobuf.Writer;

    /**
     * Encodes the specified CanvasData message, length delimited. Does not implicitly {@link CanvasData.verify|verify} messages.
     * @param message CanvasData message or plain object to encode
     * @param [writer] Writer to encode to
     * @returns Writer
     */
    public static encodeDelimited(message: ICanvasData, writer?: $protobuf.Writer): $protobuf.Writer;

    /**
     * Decodes a CanvasData message from the specified reader or buffer.
     * @param reader Reader or buffer to decode from
     * @param [length] Message length if known beforehand
     * @returns CanvasData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): CanvasData;

    /**
     * Decodes a CanvasData message from the specified reader or buffer, length delimited.
     * @param reader Reader or buffer to decode from
     * @returns CanvasData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): CanvasData;

    /**
     * Verifies a CanvasData message.
     * @param message Plain object to verify
     * @returns `null` if valid, otherwise the reason why it is not
     */
    public static verify(message: { [k: string]: any }): (string|null);

    /**
     * Creates a CanvasData message from a plain object. Also converts values to their respective internal types.
     * @param object Plain object
     * @returns CanvasData
     */
    public static fromObject(object: { [k: string]: any }): CanvasData;

    /**
     * Creates a plain object from a CanvasData message. Also converts values to other types if specified.
     * @param message CanvasData
     * @param [options] Conversion options
     * @returns Plain object
     */
    public static toObject(message: CanvasData, options?: $protobuf.IConversionOptions): { [k: string]: any };

    /**
     * Converts this CanvasData to JSON.
     * @returns JSON object
     */
    public toJSON(): { [k: string]: any };
}
